// Autogenerated from Pigeon (v2.0.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name
// @dart = 2.12
import 'dart:async';
import 'dart:typed_data' show Uint8List, Int32List, Int64List, Float64List;

import 'package:flutter/foundation.dart' show WriteBuffer, ReadBuffer;
import 'package:flutter/services.dart';

enum BarcodeSymbology {
  qr,
  code39,
  code128,
  pdf417,
}

enum DocumentSide {
  front,
  back,
}

enum DocumentType {
  idCard,
  driversLicence,
  passport,
  refugee,
  emergencyPassport,
  residencePermitTypeI,
  residencePermitTypeII,
  visa,
  unknown,
}

enum ValidatorType {
  countryAllowlist,
  countryBlocklist,
  hasMrz,
  documentTypes,
  mrzAvailable,
  nfcKeyWhenAvailable,
}

enum DocumentFilterType {
  documentTypeAllowList,
  documentAllowList,
  documentBlockList,
}

enum InstructionScreenId {
  documentChooserTabBarInstruction,
  mrzPresentFlowInstruction,
  mrzScanFlowInstruction,
}

enum InstructionScreenType {
  media,
  hidden,
  defaultType,
  web,
}

enum BacStatus {
  success,
  failed,
  notChecked,
  randomFailed,
}

enum AaStatus {
  success,
  signatureFailed,
  failed,
  notPresent,
  notChecked,
}

enum RootCertificateStatus {
  notFound,
  notChecked,
  valid,
  invalid,
  revoked,
}

enum CaStatus {
  success,
  failed,
  notPresent,
  notChecked,
}

enum ReadStatus {
  noAccess,
  fileNotFound,
  success,
  failed,
}

enum NfcInstructionScreenId {
  nfcScanFlowInstruction,
}

enum LivenessCheckStatus {
  success,
  undetermined,
  skipped,
  notStarted,
  failed,
}

enum LivenessCheckType {
  closeEyes,
  tilt,
  speech,
  faceMatching,
}

class MrzDataResult {
  MrzDataResult({
    this.mrzString,
    this.format,
    this.documentType,
    this.documentSubType,
    this.countryCode,
    this.lastName,
    this.firstName,
    this.documentNumber,
    this.documentNumberCheckDigit,
    this.nationality,
    this.dateOfBirthRaw,
    this.dateOfBirthCheckDigit,
    this.sex,
    this.dateOfExpiryRaw,
    this.dateOfExpiryCheckDigit,
    this.optionalData,
    this.optionalDataCheckDigit,
    this.optionalDataTwo,
    this.compositeCheckDigit,
    this.documentSpecificData,
    this.nfcKey,
    this.validityScore,
    this.isNfcKeyValid,
    this.isDocumentCodeValid,
    this.isDocumentNumberValid,
    this.isDateOfBirthValid,
    this.isDateOfExpiryValid,
    this.isCompositeValid,
    this.isOptionalDataValid,
    this.isLine1LengthValid,
    this.isLine2LengthValid,
    this.isLine3LengthValid,
  });

  String? mrzString;
  String? format;
  String? documentType;
  String? documentSubType;
  String? countryCode;
  String? lastName;
  String? firstName;
  String? documentNumber;
  String? documentNumberCheckDigit;
  String? nationality;
  String? dateOfBirthRaw;
  String? dateOfBirthCheckDigit;
  String? sex;
  String? dateOfExpiryRaw;
  String? dateOfExpiryCheckDigit;
  String? optionalData;
  String? optionalDataCheckDigit;
  String? optionalDataTwo;
  String? compositeCheckDigit;
  Map<String?, String?>? documentSpecificData;
  String? nfcKey;
  double? validityScore;
  bool? isNfcKeyValid;
  bool? isDocumentCodeValid;
  bool? isDocumentNumberValid;
  bool? isDateOfBirthValid;
  bool? isDateOfExpiryValid;
  bool? isCompositeValid;
  bool? isOptionalDataValid;
  bool? isLine1LengthValid;
  bool? isLine2LengthValid;
  bool? isLine3LengthValid;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['mrzString'] = mrzString;
    pigeonMap['format'] = format;
    pigeonMap['documentType'] = documentType;
    pigeonMap['documentSubType'] = documentSubType;
    pigeonMap['countryCode'] = countryCode;
    pigeonMap['lastName'] = lastName;
    pigeonMap['firstName'] = firstName;
    pigeonMap['documentNumber'] = documentNumber;
    pigeonMap['documentNumberCheckDigit'] = documentNumberCheckDigit;
    pigeonMap['nationality'] = nationality;
    pigeonMap['dateOfBirthRaw'] = dateOfBirthRaw;
    pigeonMap['dateOfBirthCheckDigit'] = dateOfBirthCheckDigit;
    pigeonMap['sex'] = sex;
    pigeonMap['dateOfExpiryRaw'] = dateOfExpiryRaw;
    pigeonMap['dateOfExpiryCheckDigit'] = dateOfExpiryCheckDigit;
    pigeonMap['optionalData'] = optionalData;
    pigeonMap['optionalDataCheckDigit'] = optionalDataCheckDigit;
    pigeonMap['optionalDataTwo'] = optionalDataTwo;
    pigeonMap['compositeCheckDigit'] = compositeCheckDigit;
    pigeonMap['documentSpecificData'] = documentSpecificData;
    pigeonMap['nfcKey'] = nfcKey;
    pigeonMap['validityScore'] = validityScore;
    pigeonMap['isNfcKeyValid'] = isNfcKeyValid;
    pigeonMap['isDocumentCodeValid'] = isDocumentCodeValid;
    pigeonMap['isDocumentNumberValid'] = isDocumentNumberValid;
    pigeonMap['isDateOfBirthValid'] = isDateOfBirthValid;
    pigeonMap['isDateOfExpiryValid'] = isDateOfExpiryValid;
    pigeonMap['isCompositeValid'] = isCompositeValid;
    pigeonMap['isOptionalDataValid'] = isOptionalDataValid;
    pigeonMap['isLine1LengthValid'] = isLine1LengthValid;
    pigeonMap['isLine2LengthValid'] = isLine2LengthValid;
    pigeonMap['isLine3LengthValid'] = isLine3LengthValid;
    return pigeonMap;
  }

  static MrzDataResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return MrzDataResult(
      mrzString: pigeonMap['mrzString'] as String?,
      format: pigeonMap['format'] as String?,
      documentType: pigeonMap['documentType'] as String?,
      documentSubType: pigeonMap['documentSubType'] as String?,
      countryCode: pigeonMap['countryCode'] as String?,
      lastName: pigeonMap['lastName'] as String?,
      firstName: pigeonMap['firstName'] as String?,
      documentNumber: pigeonMap['documentNumber'] as String?,
      documentNumberCheckDigit: pigeonMap['documentNumberCheckDigit'] as String?,
      nationality: pigeonMap['nationality'] as String?,
      dateOfBirthRaw: pigeonMap['dateOfBirthRaw'] as String?,
      dateOfBirthCheckDigit: pigeonMap['dateOfBirthCheckDigit'] as String?,
      sex: pigeonMap['sex'] as String?,
      dateOfExpiryRaw: pigeonMap['dateOfExpiryRaw'] as String?,
      dateOfExpiryCheckDigit: pigeonMap['dateOfExpiryCheckDigit'] as String?,
      optionalData: pigeonMap['optionalData'] as String?,
      optionalDataCheckDigit: pigeonMap['optionalDataCheckDigit'] as String?,
      optionalDataTwo: pigeonMap['optionalDataTwo'] as String?,
      compositeCheckDigit: pigeonMap['compositeCheckDigit'] as String?,
      documentSpecificData: (pigeonMap['documentSpecificData'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
      nfcKey: pigeonMap['nfcKey'] as String?,
      validityScore: pigeonMap['validityScore'] as double?,
      isNfcKeyValid: pigeonMap['isNfcKeyValid'] as bool?,
      isDocumentCodeValid: pigeonMap['isDocumentCodeValid'] as bool?,
      isDocumentNumberValid: pigeonMap['isDocumentNumberValid'] as bool?,
      isDateOfBirthValid: pigeonMap['isDateOfBirthValid'] as bool?,
      isDateOfExpiryValid: pigeonMap['isDateOfExpiryValid'] as bool?,
      isCompositeValid: pigeonMap['isCompositeValid'] as bool?,
      isOptionalDataValid: pigeonMap['isOptionalDataValid'] as bool?,
      isLine1LengthValid: pigeonMap['isLine1LengthValid'] as bool?,
      isLine2LengthValid: pigeonMap['isLine2LengthValid'] as bool?,
      isLine3LengthValid: pigeonMap['isLine3LengthValid'] as bool?,
    );
  }
}

class CoordinatePoint {
  CoordinatePoint({
    this.x,
    this.y,
  });

  int? x;
  int? y;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['x'] = x;
    pigeonMap['y'] = y;
    return pigeonMap;
  }

  static CoordinatePoint decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CoordinatePoint(
      x: pigeonMap['x'] as int?,
      y: pigeonMap['y'] as int?,
    );
  }
}

class Polygon {
  Polygon({
    this.topLeft,
    this.topRight,
    this.bottomRight,
    this.bottomLeft,
  });

  CoordinatePoint? topLeft;
  CoordinatePoint? topRight;
  CoordinatePoint? bottomRight;
  CoordinatePoint? bottomLeft;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['topLeft'] = topLeft == null ? null : topLeft!.encode();
    pigeonMap['topRight'] = topRight == null ? null : topRight!.encode();
    pigeonMap['bottomRight'] = bottomRight == null ? null : bottomRight!.encode();
    pigeonMap['bottomLeft'] = bottomLeft == null ? null : bottomLeft!.encode();
    return pigeonMap;
  }

  static Polygon decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return Polygon(
      topLeft: pigeonMap['topLeft'] != null
          ? CoordinatePoint.decode(pigeonMap['topLeft']!)
          : null,
      topRight: pigeonMap['topRight'] != null
          ? CoordinatePoint.decode(pigeonMap['topRight']!)
          : null,
      bottomRight: pigeonMap['bottomRight'] != null
          ? CoordinatePoint.decode(pigeonMap['bottomRight']!)
          : null,
      bottomLeft: pigeonMap['bottomLeft'] != null
          ? CoordinatePoint.decode(pigeonMap['bottomLeft']!)
          : null,
    );
  }
}

class DocumentZoneResult {
  DocumentZoneResult({
    this.title,
    this.side,
    this.x,
    this.y,
    this.width,
    this.height,
    this.block,
  });

  String? title;
  String? side;
  double? x;
  double? y;
  double? width;
  double? height;
  bool? block;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['title'] = title;
    pigeonMap['side'] = side;
    pigeonMap['x'] = x;
    pigeonMap['y'] = y;
    pigeonMap['width'] = width;
    pigeonMap['height'] = height;
    pigeonMap['block'] = block;
    return pigeonMap;
  }

  static DocumentZoneResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return DocumentZoneResult(
      title: pigeonMap['title'] as String?,
      side: pigeonMap['side'] as String?,
      x: pigeonMap['x'] as double?,
      y: pigeonMap['y'] as double?,
      width: pigeonMap['width'] as double?,
      height: pigeonMap['height'] as double?,
      block: pigeonMap['block'] as bool?,
    );
  }
}

class DocumentResult {
  DocumentResult({
    this.uuid,
    this.type,
    this.model,
    this.country,
    this.widthMm,
    this.heightMm,
    this.sampleFront,
    this.mrzType,
    this.mrzStart,
    this.nfcType,
    this.zones,
    this.numberOfSides,
    this.hasMrz,
  });

  String? uuid;
  String? type;
  String? model;
  String? country;
  double? widthMm;
  double? heightMm;
  String? sampleFront;
  String? mrzType;
  String? mrzStart;
  String? nfcType;
  List<DocumentZoneResult?>? zones;
  int? numberOfSides;
  bool? hasMrz;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['uuid'] = uuid;
    pigeonMap['type'] = type;
    pigeonMap['model'] = model;
    pigeonMap['country'] = country;
    pigeonMap['widthMm'] = widthMm;
    pigeonMap['heightMm'] = heightMm;
    pigeonMap['sampleFront'] = sampleFront;
    pigeonMap['mrzType'] = mrzType;
    pigeonMap['mrzStart'] = mrzStart;
    pigeonMap['nfcType'] = nfcType;
    pigeonMap['zones'] = zones;
    pigeonMap['numberOfSides'] = numberOfSides;
    pigeonMap['hasMrz'] = hasMrz;
    return pigeonMap;
  }

  static DocumentResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return DocumentResult(
      uuid: pigeonMap['uuid'] as String?,
      type: pigeonMap['type'] as String?,
      model: pigeonMap['model'] as String?,
      country: pigeonMap['country'] as String?,
      widthMm: pigeonMap['widthMm'] as double?,
      heightMm: pigeonMap['heightMm'] as double?,
      sampleFront: pigeonMap['sampleFront'] as String?,
      mrzType: pigeonMap['mrzType'] as String?,
      mrzStart: pigeonMap['mrzStart'] as String?,
      nfcType: pigeonMap['nfcType'] as String?,
      zones: (pigeonMap['zones'] as List<Object?>?)?.cast<DocumentZoneResult?>(),
      numberOfSides: pigeonMap['numberOfSides'] as int?,
      hasMrz: pigeonMap['hasMrz'] as bool?,
    );
  }
}

class BarcodeResult {
  BarcodeResult({
    this.symbology,
    this.side,
    this.data,
  });

  BarcodeSymbology? symbology;
  DocumentSide? side;
  String? data;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['symbology'] = symbology == null ? null : symbology!.index;
    pigeonMap['side'] = side == null ? null : side!.index;
    pigeonMap['data'] = data;
    return pigeonMap;
  }

  static BarcodeResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return BarcodeResult(
      symbology: pigeonMap['symbology'] != null
          ? BarcodeSymbology.values[pigeonMap['symbology']! as int]
          : null,
      side: pigeonMap['side'] != null
          ? DocumentSide.values[pigeonMap['side']! as int]
          : null,
      data: pigeonMap['data'] as String?,
    );
  }
}

class CoreResult {
  CoreResult({
    this.frontImage,
    this.frontDocumentPosition,
    this.backImage,
    this.backDocumentPosition,
    this.mrzData,
    this.document,
    this.documentBarcodes,
    this.visualInspectionZoneResult,
  });

  Uint8List? frontImage;
  Polygon? frontDocumentPosition;
  Uint8List? backImage;
  Polygon? backDocumentPosition;
  MrzDataResult? mrzData;
  DocumentResult? document;
  List<BarcodeResult?>? documentBarcodes;
  Map<String?, String?>? visualInspectionZoneResult;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['frontImage'] = frontImage;
    pigeonMap['frontDocumentPosition'] = frontDocumentPosition == null ? null : frontDocumentPosition!.encode();
    pigeonMap['backImage'] = backImage;
    pigeonMap['backDocumentPosition'] = backDocumentPosition == null ? null : backDocumentPosition!.encode();
    pigeonMap['mrzData'] = mrzData == null ? null : mrzData!.encode();
    pigeonMap['document'] = document == null ? null : document!.encode();
    pigeonMap['documentBarcodes'] = documentBarcodes;
    pigeonMap['visualInspectionZoneResult'] = visualInspectionZoneResult;
    return pigeonMap;
  }

  static CoreResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CoreResult(
      frontImage: pigeonMap['frontImage'] as Uint8List?,
      frontDocumentPosition: pigeonMap['frontDocumentPosition'] != null
          ? Polygon.decode(pigeonMap['frontDocumentPosition']!)
          : null,
      backImage: pigeonMap['backImage'] as Uint8List?,
      backDocumentPosition: pigeonMap['backDocumentPosition'] != null
          ? Polygon.decode(pigeonMap['backDocumentPosition']!)
          : null,
      mrzData: pigeonMap['mrzData'] != null
          ? MrzDataResult.decode(pigeonMap['mrzData']!)
          : null,
      document: pigeonMap['document'] != null
          ? DocumentResult.decode(pigeonMap['document']!)
          : null,
      documentBarcodes: (pigeonMap['documentBarcodes'] as List<Object?>?)?.cast<BarcodeResult?>(),
      visualInspectionZoneResult: (pigeonMap['visualInspectionZoneResult'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
    );
  }
}

class Validator {
  Validator({
    this.type,
    this.args,
  });

  ValidatorType? type;
  Map<String?, Object?>? args;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['type'] = type == null ? null : type!.index;
    pigeonMap['args'] = args;
    return pigeonMap;
  }

  static Validator decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return Validator(
      type: pigeonMap['type'] != null
          ? ValidatorType.values[pigeonMap['type']! as int]
          : null,
      args: (pigeonMap['args'] as Map<Object?, Object?>?)?.cast<String?, Object?>(),
    );
  }
}

class DocumentFilter {
  DocumentFilter({
    this.type,
    this.args,
  });

  DocumentFilterType? type;
  Map<String?, Object?>? args;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['type'] = type == null ? null : type!.index;
    pigeonMap['args'] = args;
    return pigeonMap;
  }

  static DocumentFilter decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return DocumentFilter(
      type: pigeonMap['type'] != null
          ? DocumentFilterType.values[pigeonMap['type']! as int]
          : null,
      args: (pigeonMap['args'] as Map<Object?, Object?>?)?.cast<String?, Object?>(),
    );
  }
}

class InstructionScreen {
  InstructionScreen({
    this.screen,
    this.type,
    this.title,
    this.continueButtonLabel,
    this.header,
    this.mp4FileName,
    this.instruction,
    this.url,
  });

  InstructionScreenId? screen;
  InstructionScreenType? type;
  String? title;
  String? continueButtonLabel;
  String? header;
  String? mp4FileName;
  String? instruction;
  String? url;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['screen'] = screen == null ? null : screen!.index;
    pigeonMap['type'] = type == null ? null : type!.index;
    pigeonMap['title'] = title;
    pigeonMap['continueButtonLabel'] = continueButtonLabel;
    pigeonMap['header'] = header;
    pigeonMap['mp4FileName'] = mp4FileName;
    pigeonMap['instruction'] = instruction;
    pigeonMap['url'] = url;
    return pigeonMap;
  }

  static InstructionScreen decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return InstructionScreen(
      screen: pigeonMap['screen'] != null
          ? InstructionScreenId.values[pigeonMap['screen']! as int]
          : null,
      type: pigeonMap['type'] != null
          ? InstructionScreenType.values[pigeonMap['type']! as int]
          : null,
      title: pigeonMap['title'] as String?,
      continueButtonLabel: pigeonMap['continueButtonLabel'] as String?,
      header: pigeonMap['header'] as String?,
      mp4FileName: pigeonMap['mp4FileName'] as String?,
      instruction: pigeonMap['instruction'] as String?,
      url: pigeonMap['url'] as String?,
    );
  }
}

class InstructionScreenConfiguration {
  InstructionScreenConfiguration({
    this.showInstructionScreens,
    this.instructionScreens,
  });

  bool? showInstructionScreens;
  List<InstructionScreen?>? instructionScreens;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['showInstructionScreens'] = showInstructionScreens;
    pigeonMap['instructionScreens'] = instructionScreens;
    return pigeonMap;
  }

  static InstructionScreenConfiguration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return InstructionScreenConfiguration(
      showInstructionScreens: pigeonMap['showInstructionScreens'] as bool?,
      instructionScreens: (pigeonMap['instructionScreens'] as List<Object?>?)?.cast<InstructionScreen?>(),
    );
  }
}

class ScanHelpConfiguration {
  ScanHelpConfiguration({
    this.showScanHelp,
    this.customScanHelpScreenInstructions,
    this.customScanHelpScreenMp4FileName,
  });

  bool? showScanHelp;
  String? customScanHelpScreenInstructions;
  String? customScanHelpScreenMp4FileName;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['showScanHelp'] = showScanHelp;
    pigeonMap['customScanHelpScreenInstructions'] = customScanHelpScreenInstructions;
    pigeonMap['customScanHelpScreenMp4FileName'] = customScanHelpScreenMp4FileName;
    return pigeonMap;
  }

  static ScanHelpConfiguration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return ScanHelpConfiguration(
      showScanHelp: pigeonMap['showScanHelp'] as bool?,
      customScanHelpScreenInstructions: pigeonMap['customScanHelpScreenInstructions'] as String?,
      customScanHelpScreenMp4FileName: pigeonMap['customScanHelpScreenMp4FileName'] as String?,
    );
  }
}

class Configuration {
  Configuration({
    this.requireDocumentCopy,
    this.enablePostCropping,
    this.enableManual,
    this.requireMrzContents,
    this.requireNfcWhenAvailable,
    this.readMrzContents,
    this.validators,
    this.documentFilters,
    this.documentFiltersAutoCreateValidators,
    this.customDismissButtonTitle,
    this.isScanHelpEnabled,
    this.requireCroppedImage,
    this.instructionScreenConfiguration,
    this.scanHelpConfiguration,
    this.enableVisualInspection,
  });

  bool? requireDocumentCopy;
  bool? enablePostCropping;
  bool? enableManual;
  bool? requireMrzContents;
  bool? requireNfcWhenAvailable;
  bool? readMrzContents;
  List<Validator?>? validators;
  List<DocumentFilter?>? documentFilters;
  bool? documentFiltersAutoCreateValidators;
  String? customDismissButtonTitle;
  bool? isScanHelpEnabled;
  bool? requireCroppedImage;
  InstructionScreenConfiguration? instructionScreenConfiguration;
  ScanHelpConfiguration? scanHelpConfiguration;
  bool? enableVisualInspection;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['requireDocumentCopy'] = requireDocumentCopy;
    pigeonMap['enablePostCropping'] = enablePostCropping;
    pigeonMap['enableManual'] = enableManual;
    pigeonMap['requireMrzContents'] = requireMrzContents;
    pigeonMap['requireNfcWhenAvailable'] = requireNfcWhenAvailable;
    pigeonMap['readMrzContents'] = readMrzContents;
    pigeonMap['validators'] = validators;
    pigeonMap['documentFilters'] = documentFilters;
    pigeonMap['documentFiltersAutoCreateValidators'] = documentFiltersAutoCreateValidators;
    pigeonMap['customDismissButtonTitle'] = customDismissButtonTitle;
    pigeonMap['isScanHelpEnabled'] = isScanHelpEnabled;
    pigeonMap['requireCroppedImage'] = requireCroppedImage;
    pigeonMap['instructionScreenConfiguration'] = instructionScreenConfiguration == null ? null : instructionScreenConfiguration!.encode();
    pigeonMap['scanHelpConfiguration'] = scanHelpConfiguration == null ? null : scanHelpConfiguration!.encode();
    pigeonMap['enableVisualInspection'] = enableVisualInspection;
    return pigeonMap;
  }

  static Configuration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return Configuration(
      requireDocumentCopy: pigeonMap['requireDocumentCopy'] as bool?,
      enablePostCropping: pigeonMap['enablePostCropping'] as bool?,
      enableManual: pigeonMap['enableManual'] as bool?,
      requireMrzContents: pigeonMap['requireMrzContents'] as bool?,
      requireNfcWhenAvailable: pigeonMap['requireNfcWhenAvailable'] as bool?,
      readMrzContents: pigeonMap['readMrzContents'] as bool?,
      validators: (pigeonMap['validators'] as List<Object?>?)?.cast<Validator?>(),
      documentFilters: (pigeonMap['documentFilters'] as List<Object?>?)?.cast<DocumentFilter?>(),
      documentFiltersAutoCreateValidators: pigeonMap['documentFiltersAutoCreateValidators'] as bool?,
      customDismissButtonTitle: pigeonMap['customDismissButtonTitle'] as String?,
      isScanHelpEnabled: pigeonMap['isScanHelpEnabled'] as bool?,
      requireCroppedImage: pigeonMap['requireCroppedImage'] as bool?,
      instructionScreenConfiguration: pigeonMap['instructionScreenConfiguration'] != null
          ? InstructionScreenConfiguration.decode(pigeonMap['instructionScreenConfiguration']!)
          : null,
      scanHelpConfiguration: pigeonMap['scanHelpConfiguration'] != null
          ? ScanHelpConfiguration.decode(pigeonMap['scanHelpConfiguration']!)
          : null,
      enableVisualInspection: pigeonMap['enableVisualInspection'] as bool?,
    );
  }
}

class LdsFile {
  LdsFile({
    this.data,
    this.dataHash,
    this.readStatus,
  });

  Uint8List? data;
  Uint8List? dataHash;
  ReadStatus? readStatus;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['data'] = data;
    pigeonMap['dataHash'] = dataHash;
    pigeonMap['readStatus'] = readStatus == null ? null : readStatus!.index;
    return pigeonMap;
  }

  static LdsFile decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return LdsFile(
      data: pigeonMap['data'] as Uint8List?,
      dataHash: pigeonMap['dataHash'] as Uint8List?,
      readStatus: pigeonMap['readStatus'] != null
          ? ReadStatus.values[pigeonMap['readStatus']! as int]
          : null,
    );
  }
}

class X509Certificate {
  X509Certificate({
    this.version,
    this.serialNumber,
    this.signatureAlgorithmOID,
    this.signatureAlgorithmName,
    this.signatureAlgorithmParams,
    this.issuerName,
    this.notBefore,
    this.notAfter,
    this.subjectName,
    this.tbsCertificate,
    this.signature,
    this.issuerUniqueID,
    this.subjectUniqueID,
    this.keyUsage,
    this.extendedKeyUsage,
  });

  int? version;
  int? serialNumber;
  String? signatureAlgorithmOID;
  String? signatureAlgorithmName;
  Uint8List? signatureAlgorithmParams;
  String? issuerName;
  String? notBefore;
  String? notAfter;
  String? subjectName;
  Uint8List? tbsCertificate;
  Uint8List? signature;
  List<bool?>? issuerUniqueID;
  List<bool?>? subjectUniqueID;
  List<bool?>? keyUsage;
  List<String?>? extendedKeyUsage;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['version'] = version;
    pigeonMap['serialNumber'] = serialNumber;
    pigeonMap['signatureAlgorithmOID'] = signatureAlgorithmOID;
    pigeonMap['signatureAlgorithmName'] = signatureAlgorithmName;
    pigeonMap['signatureAlgorithmParams'] = signatureAlgorithmParams;
    pigeonMap['issuerName'] = issuerName;
    pigeonMap['notBefore'] = notBefore;
    pigeonMap['notAfter'] = notAfter;
    pigeonMap['subjectName'] = subjectName;
    pigeonMap['tbsCertificate'] = tbsCertificate;
    pigeonMap['signature'] = signature;
    pigeonMap['issuerUniqueID'] = issuerUniqueID;
    pigeonMap['subjectUniqueID'] = subjectUniqueID;
    pigeonMap['keyUsage'] = keyUsage;
    pigeonMap['extendedKeyUsage'] = extendedKeyUsage;
    return pigeonMap;
  }

  static X509Certificate decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return X509Certificate(
      version: pigeonMap['version'] as int?,
      serialNumber: pigeonMap['serialNumber'] as int?,
      signatureAlgorithmOID: pigeonMap['signatureAlgorithmOID'] as String?,
      signatureAlgorithmName: pigeonMap['signatureAlgorithmName'] as String?,
      signatureAlgorithmParams: pigeonMap['signatureAlgorithmParams'] as Uint8List?,
      issuerName: pigeonMap['issuerName'] as String?,
      notBefore: pigeonMap['notBefore'] as String?,
      notAfter: pigeonMap['notAfter'] as String?,
      subjectName: pigeonMap['subjectName'] as String?,
      tbsCertificate: pigeonMap['tbsCertificate'] as Uint8List?,
      signature: pigeonMap['signature'] as Uint8List?,
      issuerUniqueID: (pigeonMap['issuerUniqueID'] as List<Object?>?)?.cast<bool?>(),
      subjectUniqueID: (pigeonMap['subjectUniqueID'] as List<Object?>?)?.cast<bool?>(),
      keyUsage: (pigeonMap['keyUsage'] as List<Object?>?)?.cast<bool?>(),
      extendedKeyUsage: (pigeonMap['extendedKeyUsage'] as List<Object?>?)?.cast<String?>(),
    );
  }
}

class NfcResult {
  NfcResult({
    this.originality,
    this.authenticity,
    this.confidentiality,
    this.mrzMatch,
    this.comSodMatch,
    this.bacStatus,
    this.activeAuthenticationStatus,
    this.documentCertificateValid,
    this.signingCertificateMatchesWithParent,
    this.scanCompleted,
    this.chipAuthenticationStatus,
    this.documentSignatureCorrect,
    this.photo,
    this.mrzData,
    this.dataGroups,
    this.documentCertificate,
    this.iOSDocumentCertificate,
    this.sodHashes,
    this.sodData,
    this.featurePoints,
    this.mimeBytes,
    this.aaDigestAlgorithm,
    this.chipAuthenticationOid,
    this.chipAuthenticationAgreementAlgorithm,
    this.chipAuthenticationPublicKeyAlgorithm,
    this.signingCertificate,
    this.iOSSigningCertificate,
  });

  bool? originality;
  bool? authenticity;
  bool? confidentiality;
  bool? mrzMatch;
  bool? comSodMatch;
  BacStatus? bacStatus;
  AaStatus? activeAuthenticationStatus;
  bool? documentCertificateValid;
  RootCertificateStatus? signingCertificateMatchesWithParent;
  bool? scanCompleted;
  CaStatus? chipAuthenticationStatus;
  bool? documentSignatureCorrect;
  Uint8List? photo;
  MrzDataResult? mrzData;
  Map<int?, LdsFile?>? dataGroups;
  X509Certificate? documentCertificate;
  Uint8List? iOSDocumentCertificate;
  Map<int?, Uint8List?>? sodHashes;
  Uint8List? sodData;
  int? featurePoints;
  Uint8List? mimeBytes;
  String? aaDigestAlgorithm;
  String? chipAuthenticationOid;
  String? chipAuthenticationAgreementAlgorithm;
  String? chipAuthenticationPublicKeyAlgorithm;
  X509Certificate? signingCertificate;
  Uint8List? iOSSigningCertificate;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['originality'] = originality;
    pigeonMap['authenticity'] = authenticity;
    pigeonMap['confidentiality'] = confidentiality;
    pigeonMap['mrzMatch'] = mrzMatch;
    pigeonMap['comSodMatch'] = comSodMatch;
    pigeonMap['bacStatus'] = bacStatus == null ? null : bacStatus!.index;
    pigeonMap['activeAuthenticationStatus'] = activeAuthenticationStatus == null ? null : activeAuthenticationStatus!.index;
    pigeonMap['documentCertificateValid'] = documentCertificateValid;
    pigeonMap['signingCertificateMatchesWithParent'] = signingCertificateMatchesWithParent == null ? null : signingCertificateMatchesWithParent!.index;
    pigeonMap['scanCompleted'] = scanCompleted;
    pigeonMap['chipAuthenticationStatus'] = chipAuthenticationStatus == null ? null : chipAuthenticationStatus!.index;
    pigeonMap['documentSignatureCorrect'] = documentSignatureCorrect;
    pigeonMap['photo'] = photo;
    pigeonMap['mrzData'] = mrzData == null ? null : mrzData!.encode();
    pigeonMap['dataGroups'] = dataGroups;
    pigeonMap['documentCertificate'] = documentCertificate == null ? null : documentCertificate!.encode();
    pigeonMap['iOSDocumentCertificate'] = iOSDocumentCertificate;
    pigeonMap['sodHashes'] = sodHashes;
    pigeonMap['sodData'] = sodData;
    pigeonMap['featurePoints'] = featurePoints;
    pigeonMap['mimeBytes'] = mimeBytes;
    pigeonMap['aaDigestAlgorithm'] = aaDigestAlgorithm;
    pigeonMap['chipAuthenticationOid'] = chipAuthenticationOid;
    pigeonMap['chipAuthenticationAgreementAlgorithm'] = chipAuthenticationAgreementAlgorithm;
    pigeonMap['chipAuthenticationPublicKeyAlgorithm'] = chipAuthenticationPublicKeyAlgorithm;
    pigeonMap['signingCertificate'] = signingCertificate == null ? null : signingCertificate!.encode();
    pigeonMap['iOSSigningCertificate'] = iOSSigningCertificate;
    return pigeonMap;
  }

  static NfcResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return NfcResult(
      originality: pigeonMap['originality'] as bool?,
      authenticity: pigeonMap['authenticity'] as bool?,
      confidentiality: pigeonMap['confidentiality'] as bool?,
      mrzMatch: pigeonMap['mrzMatch'] as bool?,
      comSodMatch: pigeonMap['comSodMatch'] as bool?,
      bacStatus: pigeonMap['bacStatus'] != null
          ? BacStatus.values[pigeonMap['bacStatus']! as int]
          : null,
      activeAuthenticationStatus: pigeonMap['activeAuthenticationStatus'] != null
          ? AaStatus.values[pigeonMap['activeAuthenticationStatus']! as int]
          : null,
      documentCertificateValid: pigeonMap['documentCertificateValid'] as bool?,
      signingCertificateMatchesWithParent: pigeonMap['signingCertificateMatchesWithParent'] != null
          ? RootCertificateStatus.values[pigeonMap['signingCertificateMatchesWithParent']! as int]
          : null,
      scanCompleted: pigeonMap['scanCompleted'] as bool?,
      chipAuthenticationStatus: pigeonMap['chipAuthenticationStatus'] != null
          ? CaStatus.values[pigeonMap['chipAuthenticationStatus']! as int]
          : null,
      documentSignatureCorrect: pigeonMap['documentSignatureCorrect'] as bool?,
      photo: pigeonMap['photo'] as Uint8List?,
      mrzData: pigeonMap['mrzData'] != null
          ? MrzDataResult.decode(pigeonMap['mrzData']!)
          : null,
      dataGroups: (pigeonMap['dataGroups'] as Map<Object?, Object?>?)?.cast<int?, LdsFile?>(),
      documentCertificate: pigeonMap['documentCertificate'] != null
          ? X509Certificate.decode(pigeonMap['documentCertificate']!)
          : null,
      iOSDocumentCertificate: pigeonMap['iOSDocumentCertificate'] as Uint8List?,
      sodHashes: (pigeonMap['sodHashes'] as Map<Object?, Object?>?)?.cast<int?, Uint8List?>(),
      sodData: pigeonMap['sodData'] as Uint8List?,
      featurePoints: pigeonMap['featurePoints'] as int?,
      mimeBytes: pigeonMap['mimeBytes'] as Uint8List?,
      aaDigestAlgorithm: pigeonMap['aaDigestAlgorithm'] as String?,
      chipAuthenticationOid: pigeonMap['chipAuthenticationOid'] as String?,
      chipAuthenticationAgreementAlgorithm: pigeonMap['chipAuthenticationAgreementAlgorithm'] as String?,
      chipAuthenticationPublicKeyAlgorithm: pigeonMap['chipAuthenticationPublicKeyAlgorithm'] as String?,
      signingCertificate: pigeonMap['signingCertificate'] != null
          ? X509Certificate.decode(pigeonMap['signingCertificate']!)
          : null,
      iOSSigningCertificate: pigeonMap['iOSSigningCertificate'] as Uint8List?,
    );
  }
}

class NfcConfiguration {
  NfcConfiguration({
    this.retrieveImage,
    this.showDismissButton,
    this.customDismissButtonTitle,
    this.showInstructionScreens,
    this.instructionScreenConfiguration,
    this.scanHelpConfiguration,
  });

  bool? retrieveImage;
  bool? showDismissButton;
  String? customDismissButtonTitle;
  bool? showInstructionScreens;
  NfcInstructionScreenConfiguration? instructionScreenConfiguration;
  ScanHelpConfiguration? scanHelpConfiguration;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['retrieveImage'] = retrieveImage;
    pigeonMap['showDismissButton'] = showDismissButton;
    pigeonMap['customDismissButtonTitle'] = customDismissButtonTitle;
    pigeonMap['showInstructionScreens'] = showInstructionScreens;
    pigeonMap['instructionScreenConfiguration'] = instructionScreenConfiguration == null ? null : instructionScreenConfiguration!.encode();
    pigeonMap['scanHelpConfiguration'] = scanHelpConfiguration == null ? null : scanHelpConfiguration!.encode();
    return pigeonMap;
  }

  static NfcConfiguration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return NfcConfiguration(
      retrieveImage: pigeonMap['retrieveImage'] as bool?,
      showDismissButton: pigeonMap['showDismissButton'] as bool?,
      customDismissButtonTitle: pigeonMap['customDismissButtonTitle'] as String?,
      showInstructionScreens: pigeonMap['showInstructionScreens'] as bool?,
      instructionScreenConfiguration: pigeonMap['instructionScreenConfiguration'] != null
          ? NfcInstructionScreenConfiguration.decode(pigeonMap['instructionScreenConfiguration']!)
          : null,
      scanHelpConfiguration: pigeonMap['scanHelpConfiguration'] != null
          ? ScanHelpConfiguration.decode(pigeonMap['scanHelpConfiguration']!)
          : null,
    );
  }
}

class NfcInstructionScreenConfiguration {
  NfcInstructionScreenConfiguration({
    this.showInstructionScreens,
    this.instructionScreens,
  });

  bool? showInstructionScreens;
  List<NfcInstructionScreen?>? instructionScreens;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['showInstructionScreens'] = showInstructionScreens;
    pigeonMap['instructionScreens'] = instructionScreens;
    return pigeonMap;
  }

  static NfcInstructionScreenConfiguration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return NfcInstructionScreenConfiguration(
      showInstructionScreens: pigeonMap['showInstructionScreens'] as bool?,
      instructionScreens: (pigeonMap['instructionScreens'] as List<Object?>?)?.cast<NfcInstructionScreen?>(),
    );
  }
}

class NfcInstructionScreen {
  NfcInstructionScreen({
    this.screen,
    this.type,
    this.title,
    this.continueButtonLabel,
    this.header,
    this.mp4FileName,
    this.instruction,
    this.url,
  });

  NfcInstructionScreenId? screen;
  InstructionScreenType? type;
  String? title;
  String? continueButtonLabel;
  String? header;
  String? mp4FileName;
  String? instruction;
  String? url;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['screen'] = screen == null ? null : screen!.index;
    pigeonMap['type'] = type == null ? null : type!.index;
    pigeonMap['title'] = title;
    pigeonMap['continueButtonLabel'] = continueButtonLabel;
    pigeonMap['header'] = header;
    pigeonMap['mp4FileName'] = mp4FileName;
    pigeonMap['instruction'] = instruction;
    pigeonMap['url'] = url;
    return pigeonMap;
  }

  static NfcInstructionScreen decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return NfcInstructionScreen(
      screen: pigeonMap['screen'] != null
          ? NfcInstructionScreenId.values[pigeonMap['screen']! as int]
          : null,
      type: pigeonMap['type'] != null
          ? InstructionScreenType.values[pigeonMap['type']! as int]
          : null,
      title: pigeonMap['title'] as String?,
      continueButtonLabel: pigeonMap['continueButtonLabel'] as String?,
      header: pigeonMap['header'] as String?,
      mp4FileName: pigeonMap['mp4FileName'] as String?,
      instruction: pigeonMap['instruction'] as String?,
      url: pigeonMap['url'] as String?,
    );
  }
}

class LivenessCheckResult {
  LivenessCheckResult({
    this.name,
    this.instruction,
    this.status,
    this.recordingFileName,
    this.checkSpecificData,
  });

  String? name;
  String? instruction;
  LivenessCheckStatus? status;
  String? recordingFileName;
  Map<String?, Object?>? checkSpecificData;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['name'] = name;
    pigeonMap['instruction'] = instruction;
    pigeonMap['status'] = status == null ? null : status!.index;
    pigeonMap['recordingFileName'] = recordingFileName;
    pigeonMap['checkSpecificData'] = checkSpecificData;
    return pigeonMap;
  }

  static LivenessCheckResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return LivenessCheckResult(
      name: pigeonMap['name'] as String?,
      instruction: pigeonMap['instruction'] as String?,
      status: pigeonMap['status'] != null
          ? LivenessCheckStatus.values[pigeonMap['status']! as int]
          : null,
      recordingFileName: pigeonMap['recordingFileName'] as String?,
      checkSpecificData: (pigeonMap['checkSpecificData'] as Map<Object?, Object?>?)?.cast<String?, Object?>(),
    );
  }
}

class LivenessResult {
  LivenessResult({
    this.automaticChecksPassed,
    this.successRatio,
    this.resultList,
  });

  bool? automaticChecksPassed;
  double? successRatio;
  List<LivenessCheckResult?>? resultList;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['automaticChecksPassed'] = automaticChecksPassed;
    pigeonMap['successRatio'] = successRatio;
    pigeonMap['resultList'] = resultList;
    return pigeonMap;
  }

  static LivenessResult decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return LivenessResult(
      automaticChecksPassed: pigeonMap['automaticChecksPassed'] as bool?,
      successRatio: pigeonMap['successRatio'] as double?,
      resultList: (pigeonMap['resultList'] as List<Object?>?)?.cast<LivenessCheckResult?>(),
    );
  }
}

class LivenessCheck {
  LivenessCheck({
    this.type,
    this.args,
  });

  LivenessCheckType? type;
  Map<String?, Object?>? args;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['type'] = type == null ? null : type!.index;
    pigeonMap['args'] = args;
    return pigeonMap;
  }

  static LivenessCheck decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return LivenessCheck(
      type: pigeonMap['type'] != null
          ? LivenessCheckType.values[pigeonMap['type']! as int]
          : null,
      args: (pigeonMap['args'] as Map<Object?, Object?>?)?.cast<String?, Object?>(),
    );
  }
}

class LivenessConfiguration {
  LivenessConfiguration({
    this.showDismissButton,
    this.checks,
    this.resultOutputDirectory,
    this.customDismissButtonTitle,
  });

  bool? showDismissButton;
  List<LivenessCheck?>? checks;
  String? resultOutputDirectory;
  String? customDismissButtonTitle;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['showDismissButton'] = showDismissButton;
    pigeonMap['checks'] = checks;
    pigeonMap['resultOutputDirectory'] = resultOutputDirectory;
    pigeonMap['customDismissButtonTitle'] = customDismissButtonTitle;
    return pigeonMap;
  }

  static LivenessConfiguration decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return LivenessConfiguration(
      showDismissButton: pigeonMap['showDismissButton'] as bool?,
      checks: (pigeonMap['checks'] as List<Object?>?)?.cast<LivenessCheck?>(),
      resultOutputDirectory: pigeonMap['resultOutputDirectory'] as String?,
      customDismissButtonTitle: pigeonMap['customDismissButtonTitle'] as String?,
    );
  }
}

class _CoreResultApiCodec extends StandardMessageCodec {
  const _CoreResultApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is BarcodeResult) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is CoordinatePoint) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is CoreResult) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is DocumentResult) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is DocumentZoneResult) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is MrzDataResult) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
    if (value is Polygon) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return BarcodeResult.decode(readValue(buffer)!);
      
      case 129:       
        return CoordinatePoint.decode(readValue(buffer)!);
      
      case 130:       
        return CoreResult.decode(readValue(buffer)!);
      
      case 131:       
        return DocumentResult.decode(readValue(buffer)!);
      
      case 132:       
        return DocumentZoneResult.decode(readValue(buffer)!);
      
      case 133:       
        return MrzDataResult.decode(readValue(buffer)!);
      
      case 134:       
        return Polygon.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class CoreResultApi {
  static const MessageCodec<Object?> codec = _CoreResultApiCodec();

  void onSuccess(CoreResult result);
  void onCancelled();
  void onError(String message);
  static void setup(CoreResultApi? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.CoreResultApi.onSuccess', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.CoreResultApi.onSuccess was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CoreResult? arg_result = (args[0] as CoreResult?);
          assert(arg_result != null, 'Argument for dev.flutter.pigeon.CoreResultApi.onSuccess was null, expected non-null CoreResult.');
          api.onSuccess(arg_result!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.CoreResultApi.onCancelled', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          // ignore message
          api.onCancelled();
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.CoreResultApi.onError', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.CoreResultApi.onError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_message = (args[0] as String?);
          assert(arg_message != null, 'Argument for dev.flutter.pigeon.CoreResultApi.onError was null, expected non-null String.');
          api.onError(arg_message!);
          return;
        });
      }
    }
  }
}

class _CoreApiCodec extends StandardMessageCodec {
  const _CoreApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is Configuration) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is DocumentFilter) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is InstructionScreen) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is InstructionScreenConfiguration) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is ScanHelpConfiguration) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is Validator) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return Configuration.decode(readValue(buffer)!);
      
      case 129:       
        return DocumentFilter.decode(readValue(buffer)!);
      
      case 130:       
        return InstructionScreen.decode(readValue(buffer)!);
      
      case 131:       
        return InstructionScreenConfiguration.decode(readValue(buffer)!);
      
      case 132:       
        return ScanHelpConfiguration.decode(readValue(buffer)!);
      
      case 133:       
        return Validator.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class CoreApi {
  /// Constructor for [CoreApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  CoreApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _CoreApiCodec();

  Future<void> setLicence(String arg_licence) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.CoreApi.setLicence', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_licence]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> start() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.CoreApi.start', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> configure(Configuration arg_configuration) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.CoreApi.configure', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_configuration]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }
}

class _NfcResultApiCodec extends StandardMessageCodec {
  const _NfcResultApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is LdsFile) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is MrzDataResult) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is NfcResult) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is X509Certificate) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return LdsFile.decode(readValue(buffer)!);
      
      case 129:       
        return MrzDataResult.decode(readValue(buffer)!);
      
      case 130:       
        return NfcResult.decode(readValue(buffer)!);
      
      case 131:       
        return X509Certificate.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class NfcResultApi {
  static const MessageCodec<Object?> codec = _NfcResultApiCodec();

  void onSuccess(NfcResult result);
  void onCancelled();
  void onError(String message);
  static void setup(NfcResultApi? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NfcResultApi.onSuccess', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.NfcResultApi.onSuccess was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final NfcResult? arg_result = (args[0] as NfcResult?);
          assert(arg_result != null, 'Argument for dev.flutter.pigeon.NfcResultApi.onSuccess was null, expected non-null NfcResult.');
          api.onSuccess(arg_result!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NfcResultApi.onCancelled', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          // ignore message
          api.onCancelled();
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NfcResultApi.onError', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.NfcResultApi.onError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_message = (args[0] as String?);
          assert(arg_message != null, 'Argument for dev.flutter.pigeon.NfcResultApi.onError was null, expected non-null String.');
          api.onError(arg_message!);
          return;
        });
      }
    }
  }
}

class _NfcApiCodec extends StandardMessageCodec {
  const _NfcApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is BarcodeResult) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is CoordinatePoint) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is CoreResult) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is DocumentResult) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is DocumentZoneResult) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is MrzDataResult) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
    if (value is NfcConfiguration) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else 
    if (value is NfcInstructionScreen) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else 
    if (value is NfcInstructionScreenConfiguration) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else 
    if (value is Polygon) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else 
    if (value is ScanHelpConfiguration) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return BarcodeResult.decode(readValue(buffer)!);
      
      case 129:       
        return CoordinatePoint.decode(readValue(buffer)!);
      
      case 130:       
        return CoreResult.decode(readValue(buffer)!);
      
      case 131:       
        return DocumentResult.decode(readValue(buffer)!);
      
      case 132:       
        return DocumentZoneResult.decode(readValue(buffer)!);
      
      case 133:       
        return MrzDataResult.decode(readValue(buffer)!);
      
      case 134:       
        return NfcConfiguration.decode(readValue(buffer)!);
      
      case 135:       
        return NfcInstructionScreen.decode(readValue(buffer)!);
      
      case 136:       
        return NfcInstructionScreenConfiguration.decode(readValue(buffer)!);
      
      case 137:       
        return Polygon.decode(readValue(buffer)!);
      
      case 138:       
        return ScanHelpConfiguration.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class NfcApi {
  /// Constructor for [NfcApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  NfcApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _NfcApiCodec();

  Future<void> start(NfcConfiguration arg_config, CoreResult arg_coreResult) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.NfcApi.start', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_config, arg_coreResult]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }
}

class _LivenessResultApiCodec extends StandardMessageCodec {
  const _LivenessResultApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is LivenessCheckResult) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is LivenessResult) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return LivenessCheckResult.decode(readValue(buffer)!);
      
      case 129:       
        return LivenessResult.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class LivenessResultApi {
  static const MessageCodec<Object?> codec = _LivenessResultApiCodec();

  void onSuccess(LivenessResult result);
  void onError(String message);
  static void setup(LivenessResultApi? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.LivenessResultApi.onSuccess', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.LivenessResultApi.onSuccess was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final LivenessResult? arg_result = (args[0] as LivenessResult?);
          assert(arg_result != null, 'Argument for dev.flutter.pigeon.LivenessResultApi.onSuccess was null, expected non-null LivenessResult.');
          api.onSuccess(arg_result!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.LivenessResultApi.onError', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.LivenessResultApi.onError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_message = (args[0] as String?);
          assert(arg_message != null, 'Argument for dev.flutter.pigeon.LivenessResultApi.onError was null, expected non-null String.');
          api.onError(arg_message!);
          return;
        });
      }
    }
  }
}

class _LivenessApiCodec extends StandardMessageCodec {
  const _LivenessApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is LivenessCheck) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is LivenessConfiguration) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return LivenessCheck.decode(readValue(buffer)!);
      
      case 129:       
        return LivenessConfiguration.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class LivenessApi {
  /// Constructor for [LivenessApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  LivenessApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _LivenessApiCodec();

  Future<void> start(LivenessConfiguration arg_config) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.LivenessApi.start', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_config]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }
}
